package com.student.details.models;

import lombok.Data;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.lang.reflect.Field;
import java.time.LocalDate;

@Entity
@Table(name = "student_details")
@Data
public class Student {
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Column(unique = true)
  private String email;

  @NotNull
  private String firstName, lastName, course;
  
  @NotNull
  private LocalDate dateOfBirth;
  
  public void copyFields(Student sourceStudent) {
    try {
      for (Field field : sourceStudent.getClass().getDeclaredFields()) {
        String fieldName = field.getName();
        Object sourceValue = field.get(sourceStudent);
        
        if (!fieldName.equals("id") && null != sourceValue) {
          Field destField = this.getClass().getDeclaredField(fieldName);
          destField.set(this, sourceValue);
        }
      }
    } catch (Exception ignore) { }
  }
}
